Contents
Index 🔎︎

# ScriptForge.Basic service

The ScriptForge.Basic service proposes a collection of LibreOffice Basic methods to be executed in a Python context. Basic service methods reproduce the exact syntax and behaviour of Basic builtin functions.

Typical example:

       bas.MsgBox('Display this text in a message box from a Python script')

ScriptForge.Basic service is limited to Python scripts.

## Service invocation

Before using the Basic service, import the CreateScriptService() method from the scriptforge module:

        from scriptforge import CreateScriptService
        bas = CreateScriptService("Basic")

## Properties

Name | ReadOnly | Type | Description
MB_OK, MB_OKCANCEL, MB_RETRYCANCEL, MB_YESNO, MB_YESNOCANCEL | Yes | Integer | Values: 0, 1, 5, 4, 3
MB_ICONEXCLAMATION, MB_ICONINFORMATION, MB_ICONQUESTION, MB_ICONSTOP | Yes | Integer | Values: 48, 64, 32, 16
MB_ABORTRETRYIGNORE, MB_DEFBUTTON1, MB_DEFBUTTON2, MB_DEFBUTTON3 | Yes | Integer | Values: 2, 128, 256, 512
IDABORT, IDCANCEL, IDIGNORE, IDNO, IDOK, IDRETRY, IDYES | Yes | Integer | Values: 3, 2, 5, 7, 1, 4, 6 Constants indicating MsgBox selected button.
StarDesktop | Yes | UNO object | StarDesktop object represents LibreOffice Start Center.

List of Methods in the Basic Service
CDate CDateFromUnoDateTime CDateToUnoDateTime ConvertFromUrl ConvertToUrl CreateUnoService DateAdd DateDiff DatePart | DateValue Format GetDefaultContext GetGuiType GetPathSeparator GetSystemTicks GlobalScope.BasicLibraries GlobalScope.DialogLibraries InputBox | MsgBox Now RGB ThisComponent ThisDatabaseDocument Xray

## CDate

Converts a numeric expression or a string to a datetime.datetime Python native object.

This method exposes the Basic builtin function CDate to Python scripts.

### Syntax:

svc.CDate(expression: any): obj

### Parameters:

expression: a numeric expression or a string representing a date.

When you convert a string expression, the date and time must be entered either in one of the date acceptance patterns defined for your locale setting (see LibreOffice - Preferences Tools - Options - Language Settings - Languages) or in ISO date format (momentarily, only the ISO format with hyphens, e.g. "2012-12-31" is accepted). In numeric expressions, values to the left of the decimal represent the date, beginning from December 31, 1899. Values to the right of the decimal represent the time.

### Example:

        d = bas.CDate(1000.25)
        bas.MsgBox(str(d)) # 1902-09-26 06:00:00
        bas.MsgBox(d.year) # 1902

## CDateFromUnoDateTime

Converts a UNO date/time representation to a datetime.datetime Python native object.

### Syntax:

svc.CDateFromUnoDateTime(unodate: uno): obj

### Parameters:

unodate: A UNO date/time object of one of the following types: com.sun.star.util.DateTime, com.sun.star.util.Date or com.sun.star.util.Time

### Example:

The following example creates a com.sun.star.util.DateTime object and converts it to a datetime.datetime Python object.

        import uno
        uno_date = uno.createUnoStruct('com.sun.star.util.DateTime')
        uno_date.Year = 1983
        uno_date.Month = 2
        uno_date.Day = 23
        new_date = bas.CDateFromUnoDateTime(uno_date)
        bas.MsgBox(str(new_date)) # 1983-02-23 00:00:00

## CDateToUnoDateTime

Converts a date representation into a com.sun.star.util.DateTime object.

### Syntax:

svc.CDateToUnoDateTime(date: obj): uno

### Parameters:

date: A Python date/time object of one of the following types: datetime.datetime, datetime.date, datetime.time, float (time.time) or time.struct_time.

### Example:

        from datetime import datetime
        current_datetime = datetime.now()
        uno_date = bas.CDateToUnoDateTime(current_datetime)
        bas.MsgBox(str(uno_date.Year) + "-" + str(uno_date.Month) + "-" + str(uno_date.Day))

## ConvertFromUrl

Returns a system path file name for the given file: URL.

### Syntax:

svc.ConvertFromUrl(url: str): str

### Parameters:

url: An absolute file: URL.

### Return value:

A system path file name.

### Example:

        filename = bas.ConvertFromUrl( "file:///C:/Program%20Files%20(x86)/LibreOffice/News.txt")
        bas.MsgBox(filename)

## ConvertToUrl

Returns a file: URL for the given system path.

### Syntax:

svc.ConvertToUrl(systempath: str): str

### Parameters:

systempath: A system file name as a string.

### Return value:

A file: URL as a string.

### Example:

        url = bas.ConvertToUrl( 'C:\Program Files(x86)\LibreOffice\News.txt')
        bas.MsgBox(url)

## CreateUnoService

Instantiates a UNO service with the ProcessServiceManager.

### Syntax:

svc.CreateUnoService(servicename: str): uno

### Parameters:

servicename: A fully qualified service name such as com.sun.star.ui.dialogs.FilePicker or com.sun.star.sheet.FunctionAccess.

### Example:

        dsk = bas.CreateUnoService('com.sun.star.frame.Desktop')

## DateAdd

Adds a date or time interval to a given date/time a number of times and returns the resulting date.

### Syntax:

svc.DateAdd(interval: str, number: num, date: datetime): datetime

### Parameters:

interval: A string expression from the following table, specifying the date or time interval.

interval (string value) | 설명
yyyy | 연도
q | 분기
m | 월
y | 일
w | 요일
ww | 주
d | 날짜
h | 시
n | 분
s | 초

number: A numerical expression specifying how often the interval value will be added when positive or subtracted when negative.

date: A given datetime.datetime value, the interval value will be added number times to this datetime.datetime value.

### Return value:

A datetime.datetime value.

### Example:

        dt = datetime.datetime(2004, 1, 31)
        dt = bas.DateAdd("m", 1, dt)
        print(dt)

## DateDiff

Returns the number of date or time intervals between two given date/time values.

### Syntax:

svc.DateDiff(interval: str, date1: datetime, date2: datetime, firstdayofweek = 1, firstweekofyear = 1): int

### Parameters:

interval: A string expression specifying the date interval, as detailed in above DateAdd method.

date1, date2: The two datetime.datetime values to be compared.

firstdayofweek: An optional parameter that specifies the starting day of a week.

firstdayofweek value | 설명
0 | 시스템 기본값 사용
1 | 일요일(기본값)
2 | 월요일
3 | 화요일
4 | 수요일
5 | 목요일
6 | 금요일
7 | 토요일

firstweekofyear: An optional parameter that specifies the starting week of a year.

firstweekofyear value | 설명
0 | 시스템 기본값 사용
1 | 1월 1일이 포함된 주(기본값)가 주 1입니다.
2 | 해당 연도의 4일 이상이 포함된 첫째 주가 주 1입니다.
3 | 새로운 연도의 날짜만 포함된 첫째 주가 주 1입니다.

### Return value:

A number.

### Example:

        date1 = datetime.datetime(2005,1, 1)
        date2 = datetime.datetime(2005,12,31)
        diffDays = bas.DateDiff('d', date1, date2)
        print(diffDays)

## DatePart

The DatePart function returns a specified part of a date.

### Syntax:

svc.DatePart(interval: str, date: datetime, firstdayofweek = 1, firstweekofyear = 1): int

### Parameters:

interval: A string expression specifying the date interval, as detailed in above DateAdd method.

date: The date/time from which the result is calculated.

firstdayofweek, firstweekofyear: optional parameters that respectively specify the starting day of a week and the starting week of a year, as detailed in above DateDiff method.

### Return value:

The extracted part for the given date/time.

### Example:

        print(bas.DatePart("ww", datetime.datetime(2005,12,31)
        print(bas.DatePart('q', datetime.datetime(1999,12,30)

## DateValue

Computes a date value from a date string.

### Syntax:

svc.DateValue(date: str): datetime

### Parameters:

Date: String expression that contains the date that you want to calculate. In contrast to the DateSerial function that passes years, months and days as separate numeric values, the DateValue function requests the date string to be according to either one of the date acceptance patterns defined for your locale setting (see LibreOffice - Preferences Tools - Options - Language Settings - Languages) or to ISO date format (momentarily, only the ISO format with hyphens, e.g. "2012-12-31" is accepted).

### Return value:

The computed date.

### Example:

        dt = bas.DateValue("23-02-2011")
        print(dt)

## Format

Converts a number to a string, and then formats it according to the format that you specify.

### Syntax:

svc.Format(expression: any, format = ''): str

### Parameters:

expression: Numeric expression that you want to convert to a formatted string.

format: String that specifies the format code for the number. If format is omitted, the Format function works like the LibreOffice Basic Str() function.

### Return value:

Text string.

### Formatting Codes

The following list describes the codes that you can use for formatting a numeric expression:

0: If expression has a digit at the position of the 0 in the format code, the digit is displayed, otherwise a zero is displayed.

If expression has fewer digits than the number of zeros in the format code, (on either side of the decimal), leading or trailing zeros are displayed. If the expression has more digits to the left of the decimal separator than the amount of zeros in the format code, the additional digits are displayed without formatting.

Decimal places in the expression are rounded according to the number of zeros that appear after the decimal separator in the format code.

#: If expression contains a digit at the position of the # placeholder in the format code, the digit is displayed, otherwise nothing is displayed at this position.

This symbol works like the 0, except that leading or trailing zeroes are not displayed if there are more # characters in the format code than digits in the expression. Only the relevant digits of the expression are displayed.

.: 소수점 자리 표시자는 소수 구분 기호 왼쪽 및 오른쪽의 소수점 이하 자릿수를 결정합니다.

If the format code contains only # placeholders to the left of this symbol, numbers less than 1 begin with a decimal separator. To always display a leading zero with fractional numbers, use 0 as a placeholder for the first digit to the left of the decimal separator.

%: Multiplies the expressionby 100 and inserts the percent sign (%) where the expression appears in the format code.

E- E+ e- e+ : If the format code contains at least one digit placeholder (0 or #) to the right of the symbol E-, E+, e-, or e+, the expression is formatted in the scientific or exponential format. The letter E or e is inserted between the number and the exponent. The number of placeholders for digits to the right of the symbol determines the number of digits in the exponent.

지수가 음수일 경우 E-, E+, e- 또는 e+ 기호가 있는 지수의 바로 앞에 빼기 기호가 표시됩니다. 지수가 양수일 경우 E+ 또는 e+ 기호가 있는 지수의 앞에만 더하기 기호가 표시됩니다.

The thousands delimiter is displayed if the format code contains the delimiter enclosed by digit placeholders (0 or #).

마침표를 천단위 및 소수 구분 기호로 사용할지 여부는 국가별 설정에 따라 결정됩니다. Basic 원본 코드에 직접 숫자를 입력하는 경우 항상 마침표를 소수 구분 기호로 사용합니다. 소수 구분 기호로 표시되는 실제 문자는 시스템 설정의 숫자 표기 형식에 따라 달라집니다.

- + $ ( ) space: A plus (+), minus (-), dollar ($), space, or brackets entered directly in the format code is displayed as a literal character.

여기에 나열된 것 외의 문자를 표시하려면 해당 문자 앞에 백슬래시(\)를 사용하거나 해당 문자를 따옴표(" ")로 묶어야 합니다.

\ : The backslash displays the next character in the format code.

Characters in the format code that have a special meaning can only be displayed as literal characters if they are preceded by a backslash. The backslash itself is not displayed, unless you enter a double backslash (\\) in the format code.

리터럴 문자로 표시하기 위해 서식 코드에서 백슬래시를 앞에 두어야 하는 문자로는 날짜 및 시간 서식 설정 문자(a, c, d, h, m, n, p, q, s, t, w, y, /, :), 숫자 표기 형식 설정 문자(#, 0, %, E, e, 쉼표, 마침표) 및 문자열 서식 설정 문자(@, &, <, >, !) 등이 있습니다.

You can also use the following predefined number formats. Except for "General Number", all of the predefined format codes return the number as a decimal number with two decimal places.

미리 지정된 서식을 사용할 경우 서식 이름을 따옴표로 묶어야 합니다.

### Predefined Formats

General Number: 숫자를 입력한 대로 표시합니다.

Currency: 숫자 앞에 달러 기호를 삽입하고 음수를 괄호로 묶습니다.

Fixed: 소수 구분 기호 앞에 최소한 하나 이상의 숫자를 표시합니다.

Standard: 숫자를 천단위 구분 기호와 함께 표시합니다.

Percent: 숫자에 100을 곱하고 백분율 기호를 숫자에 추가합니다.

Scientific: 숫자를 공학용 서식으로 표시합니다(예: 1000의 경우 1.00E+03으로 표시).

A format code can be divided into three sections that are separated by semicolons. The first part defines the format for positive values, the second part for negative values, and the third part for zero. If you only specify one format code, it applies to all numbers.

LibreOffice - 기본 설정도구 - 기본 설정 - 언어 설정 - 언어 에서 LibreOffice Basic에서 숫자, 날짜, 통화 서식을 제어하는 데 사용되는 로케일을 설정할 수 있습니다. Basic 서식 코드에서 소수점(.)은 항상 여러분의 로케일에 정의된 소수 구분자를 위한 자리 표시자로 사용되어 해당 문자로 바뀌게 됩니다.

날짜, 시간 및 통화 서식에 대한 국가별 설정에도 동일하게 적용됩니다. Basic 서식 코드는 사용자의 국가별 설정에 따라 해석되어 표시됩니다.

### Example:

        txt = bas.Format(6328.2, '##.##0.00')
        print(txt)

## GetDefaultContext

Returns the default context of the process service factory, if existent, else returns a null reference.

GetDefaultContext is an alternative to the getComponentContext() method available from XSCRIPTCONTEXT global variable or from uno.py module.

### Syntax:

svc.GetDefaultContext(): uno

### Return value:

The default component context is used, when instantiating services via XMultiServiceFactory. See the Professional UNO chapter in the Developer's Guide on api.libreoffice.org for more information.

### Example:

        ctx = bas.GetDefaultContext()

## GetGuiType

Returns a numerical value that specifies the graphical user interface. This function is only provided for backward compatibility with previous versions.

Refer to system() method from platform Python module to identify the operating system.

### Syntax:

svc.GetGuiType(): int

### Example:

        n = bas.GetGuiType()

## GetPathSeparator

Returns the operating system-dependent directory separator used to specify file paths.

Use os.pathsep from os Python module to identify the path separator.

### Syntax:

svc.GetPathSeparator(): str

### Example:

        sep = bas.GetPathSeparator()

## GetSystemTicks

Returns the number of system ticks provided by the operating system. You can use this function to optimize certain processes. Use this method to estimate time in milliseconds:

### Syntax:

svc.GetSystemTicks(): int

### Example:

        ticks_ini = bas.GetSystemTicks()
        time.sleep(1)
        ticks_end = bas.GetSystemTicks()
        bas.MsgBox("{} - {} = {}".format(ticks_end, ticks_ini,ticks_end - ticks_ini))

## GlobalScope.BasicLibraries

Returns the UNO object containing all shared Basic libraries and modules.

This method is the Python equivalent to GlobalScope.BasicLibraries in Basic scripts.

### Syntax:

svc.GlobalScope.BasicLibraries(): uno

### Return value:

com.sun.star.script.XLibraryContainer

### Example:

The following example loads the Gimmicks Basic library if it has not been loaded yet.

        libs = bas.GlobalScope.BasicLibraries()
        if not libs.isLibraryLoaded("Gimmicks"):
            libs.loadLibrary("Gimmicks")

## GlobalScope.DialogLibraries

Returns the UNO object containing all shared dialog libraries.

This method is the Python equivalent to GlobalScope.DialogLibraries in Basic scripts.

### Syntax:

svc.GlobalScope.DialogLibraries(): uno

### Return value:

com.sun.star.comp.sfx2.DialogLibraryContainer

### Example:

The following example shows a message box with the names of all available dialog libraries.

        dlg_libs = bas.GlobalScope.DialogLibraries()
        lib_names = dlg_libs.getElementNames()
        bas.MsgBox("\n".join(lib_names))

## InputBox

### Syntax:

svc.InputBox(prompt: str, [title: str], [default: str], [xpostwips: int, ypostwips: int]): str

### Parameters:

prompt: String expression displayed as the message in the dialog box.

title: String expression displayed in the title bar of the dialog box.

default: String expression displayed in the text box as default if no other input is given.

xpostwips: Integer expression that specifies the horizontal position of the dialog. The position is an absolute coordinate and does not refer to the window of LibreOffice.

ypostwips: Integer expression that specifies the vertical position of the dialog. The position is an absolute coordinate and does not refer to the window of LibreOffice.

If xpostwips and ypostwips are omitted, the dialog is centered on the screen. The position is specified in twips.

### Return value:

String

### Example:

        txt = s.InputBox('Please enter a phrase:', "Dear user")
        s.MsgBox(txt, s.MB_ICONINFORMATION, "Confirmation of phrase")

For in-depth information please refer to Input/Output to Screen with Python on the Wiki.

## MsgBox

Displays a dialog box containing a message and returns an optional value.
MB_xx constants help specify the dialog type, the number and type of buttons to display, plus the icon type. By adding their respective values they form bit patterns, that define the MsgBox dialog appearance.

### Syntax:

bas.MsgBox(prompt: str, [buttons: int], [title: str])[: int]

### Parameters:

prompt: String expression displayed as a message in the dialog box. Line breaks can be inserted with Chr$(13).

title: String expression displayed in the title bar of the dialog. If omitted, the title bar displays the name of the respective application.

buttons: Any integer expression that specifies the dialog type, as well as the number and type of buttons to display, and the icon type. buttons represents a combination of bit patterns, that is, a combination of elements can be defined by adding their respective values:

### Return value:

An optional integer as detailed in above IDxx properties.

### Example:

        txt = s.InputBox('Please enter a phrase:', "Dear user")
        s.MsgBox(txt, s.MB_ICONINFORMATION, "Confirmation of phrase")

For in-depth information please refer to Input/Output to Screen with Python on the Wiki.

## Now

Returns the current system date and time as a datetime.datetime Python native object.

### Syntax:

svc.Now(): datetime

### Example:

        bas.MsgBox(bas.Now(), bas.MB_OK, "Now")

## RGB

Returns an integer color value consisting of red, green, and blue components.

### Syntax:

svc.RGB(red:int, green: int, blue: int): int

### Parameters:

red: Any integer expression that represents the red component (0-255) of the composite color.

green: Any integer expression that represents the green component (0-255) of the composite color.

blue: Any integer expression that represents the blue component (0-255) of the composite color.

The color picker dialog helps computing red, green and blue components of a composite color. Changing the color of text and selecting Custom color displays the color picker dialog.

### Return value:

Integer

### Example:

        YELLOW = bas.RGB(255,255,0)

## ThisComponent

If the current component refers to a LibreOffice document, this method returns the UNO object representing the document.

The method will return None when the current component does not correspond to a document.

### Syntax:

svc.ThisComponent(): uno

### Example:

        comp = bas.ThisComponent
        bas.MsgBox("\n".join(comp.getSupportedServiceNames()))

## ThisDatabaseDocument

If the script is being executed from a Base document or any of its subcomponents this method returns the main component of the Base instance.

This method returns None otherwise.

### Syntax:

svc.ThisDatabaseDocument(): uno

### Example:

        db_doc = bas.ThisDatabaseDocument
        table_names = db_doc.DataSource.getTables().getElementNames()
        bas.MsgBox("\n".join(table_names))

Visit the OfficeDatabaseDocument API page to learn more about Base's main component structure.

## Xray

Inspect Uno objects or variables.

### Syntax:

svc.Xray(obj: any)

### Parameters:

obj: A variable or UNO object.

### Example:

        bas.Xray(bas.StarDesktop)

All ScriptForge Basic routines or identifiers that are prefixed with an underscore character "_" are reserved for internal use. They are not meant be used in Basic macros or Python scripts.

관련 주제

GlobalScope specifier

Programming with Python Scripts

uno.fileUrlToSystemPath()

uno.systemPathToFileUrl()

Input/Output to Screen with Python on the wiki

XSCRIPTCONTEXT.getComponentContext()

uno.getComponentContext()

platform.system()

os.pathsep()